Subject: Re: bug#14939: 24.3.50; `make-variable-frame-local' deprecation - alternative?

From: Juanma Barranquero <[email-masked]>
Date: Wed, 24 Jul 2013 02:02:39 +0200

On Tue, Jul 23, 2013 at 8:15 PM, Drew Adams <[email-masked]> wrote:

> That's fallacious.  My code has been working fine for those six years,
> and still works fine, because deprecation does not mean desupport.  IOW,
> if it still works, why would people think to complain?  "The very fact",
> indeed - it "surely" does not say anything at all.

Will all due respect, Drew, it's your argument that I find fallacious.
You say yourself that your code is not failing, and yet we're
discussing this in a bug thread that you started *because* of the
deprecation... So yes, if you're the only one to take that step in
five or six years, I'd say that speaks quite loudly. People who make
heavy use of frame-local variables and is worried about the
deprecation should surely take notice and bring the issue, but none
did. I'd bet the reason is, simply, that not many people use that
feature. When the whole issue of make-variable-frame-local was
discussed in emacs-devel in 2007, I did a search through the 'net and
didn't really find many uses of it (as in, almost none). I'd bet the
number has not grown since then.

> You say that there are some subtle bugs.  Well, at least for my code that
> uses `make-variable-frame-local' I have never run into a problem.  Why
> remove the simple use of frame-local variables in general just because
> there might be some corner-case subtle bugs somewhere?

That's for Stefan to decide (and he already has made his opinion
clear), but my answer would be: Not because some subtle bugs, but
because it makes Emacs source code (and manuals) more complex, and it
is not really used at all, except for a few very isolate cases. And
removing frame-local variables will be back-incompatible, but easily
fixable via normal frame parameters, which is a bit less convenient,
but vastly clearer.

> This is a move backward, IMO.  Without knowing just what problems you are
> alluding to, I would guess that they might involve variable capture when
> there are a mix of frame-local, buffer-local, and local variables with
> the same name.

Frame-local and buffer-local is currently impossible because there
were subtle interactions; you can check the emacs-devel archives if
you're interested, but IIRC there was a case where *accessing* the
value of a simultaneously buffer-local/frame-local variable could
alter what it would return *later* when accessed as buffer-local or
frame-local. Madness.